<?php
/*	Fortress(TM) Beta 1.20 by Computer Cops, LLC.
	http://computercops.biz - Paul Laudanski (Zhen-Xjell)
	http://fortress.cc - PHP CMS Security Development
        Copyright 2004 Paul Laudanski, All Rights Reserved

License: You may not modify or distribute any parts of the Fortress(TM) code without
obtaining written authorsization from the Copyright holder.  Doing so is considered
a breach of Copyright.  Receiving written authorsization requires that the Copyright
and Credits remains in tact.  

Platform:
Fortress(TM) is written to be called by any PHP developed website.  For troubleshooting
or installation helps, visit the Copryight holder's websites.

Description:
Fortress(TM) is a unique application that provides a multi-faceted approach to security
and alert notifications.  Fortress(TM) is a live work in progress and will be updated
when milestones are met, and if any patches are released.

Installation for PHP-Nuke:
Save fortress.php in your PHP-Nuke root folder.  This is generally where "config.php"
is located.  

Installation for Everything Else:
Please contact the author.

Configuration:
Go down to the configuration section of Fortress(TM), after this comment section and 
modify the variables: $sitename, $to, $mailsubject, $realname, $domain, $knights, and
$boudlers.

Usage:
Use signifies agreement to the Acceptable Use Policy at Computer Cops.

Operation:
Phase 2 (Version 1.20 beta)
   This version introduces many more features and automatically bans usernames and 
ip addresses (while checking the excluded ip addresses) once attacks are logged in
the fortress.csv file.  It alerts and bans on any bad crafted HTML tag URL injections,
and plaintext/base64/hex crafted URLs all thru HTTP GET.
   Currently only IP addresses are exluded, next release will also for usernames too.

Phase 1 (Version 1.01 beta)
   When Fortress(TM) is triggered, a silent email is activated.  The suspect is unaware
they are being tracked.

History:
Fortress(TM) is the first in its class that doesn't interface with PHP-Nuke.  Fortress(TM)
protects itself on sites using REGISTER_GLOBALS, and it takes on a truly intelligent
operation where users do not know of its existence (unless BanOnDemand is enabled).  
Silent operation ensures all suspects continue leaving more proof and evidence that they
are being malicious. This information arms you in whatever path you take for action.

As of version 1.20 beta (the second release), the bulk of UTC has been re-written as
is shown below.  It now acts as the gateway to Fortress(TM).

Union Tap Code:
The following code to be added is called Union Tap Code.  It is not part of the
Fortress(TM) code, but it is quoted here for easy access.  To install it and call
Fortress(TM), open mainfile.php and modify the following block of code to match this
(note, "Current code" signifies code that already exists within your PHP-Nuke mainfile.php
and may not need to be altered):

[----CUT----]
// Union Tap Code Final 				// Add this line
// Copyright 2004					// Add this line
// Paul Laudanski					// Add this line
// http://computercops.biz				// Add this line
// http://fortress.cc					// Add this line

define('ZERO', true);					// Add this line
include('fortress.php');				// Add this line
Bards($addr);						// Add this line

foreach ($HTTP_GET_VARS as $secvalue) {			// Current code
    if ((eregi("<[^>]*script*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*iframe*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*object*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*applet*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*meta*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*style*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*form*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("<[^>]*img*\"?[^>]*>", $secvalue)) ||	// Current code
        (eregi("\"", $secvalue))) {			// Current code
#       die ("The html tags you attempted to use are not allowed"); // Current code but either delete or comment out
        $method = "BAD-TAGS";				// Add this line
        $matches[1] = "BAD-TAGS";			// Add this line
        AlertMail($method);				// Add this line
        AlertLog($method);				// Add this line
    }							// Current code
}							// Current code

ccheck();						// Add this line
ucheck();						// Add this line
ReleaseVars();						// Add this line


if (eregi("mainfile.php",$_SERVER['PHP_SELF'])) {	// Current code
    Header("Location: index.php");			// Current code

[----CUT----]
					.end.	*/





/*	Start Configuration Section	*/

// You Must Configure This Section
$sitename = "Nuke Cops"; // Enter your website name here.
$domain = "http://nukecops.com"; // Enter your full website URL here.  Include "http://".  Do not include a trailing "/".
$to = "zx@nukecops.com"; // Enter the email address Alerts should be sent to.
$sms1 = "zx@nukecops.com"; // Cellphone or pager email address
$sms2 = "paul@computercops.biz"; // Cellphone or pager email address number two
$realname = "Zhen-Xjell"; // Enter the full name such that email Alerts may be properly titled.
$mailsubject = "Fortress(TM) Alarm @ $sitename"; // You may change the Subject here (optional).
$fortfile = "fortress.csv"; // Change this to the full path and filename you want alerts logged to.
$forthtml = "fortress.htm"; // Change this to the full path and filename you want alerts in HTML format.
$BOD = TRUE; // Enable Ban On Demand. Values: TRUE = enabled, FALSE = disabled.
$clikebg = "Pink"; // Background color used in fortress.htm for C-Like captures
$unionbg = "Yellow"; // Background color used in fortress.htm for UNION Captures
$bardbg = "Silver"; // Background color used in fortress.htm for Excluded Folks
$tagsbg = "Green"; // Background color used in fortress.htm for Bad Tags

// The following boulders array contains the list of IP addresses that get excluded from BOD.
// Usage: "IP Address" => "Description"
// List partials or entire IP addresses.  Some are provided for real use (and to serve as examples).
$boulders = array("64.68.80." => "Googlebot",
	"64.68.81." => "Googlebot",
	"64.68.82." => "Googlebot",
	"64.68.83." => "Googlebot",
	"64.68.84." => "Googlebot",
	"64.68.85." => "Googlebot",
	"64.68.86." => "Googlebot",
	"64.68.87." => "Googlebot",
	"66.196.90." => "inktomisearch",
	"209.237.224." => "Alexa", 
	"209.237.225." => "Alexa",
	"209.237.226." => "Alexa",
	"209.237.227." => "Alexa",
	"209.237.228." => "Alexa",
	"209.237.229." => "Alexa",
	"209.237.230." => "Alexa",
        "209.237.231." => "Alexa",
        "209.237.232." => "Alexa",
        "209.237.233." => "Alexa",
        "209.237.234." => "Alexa",
        "209.237.235." => "Alexa",
        "209.237.236." => "Alexa",
        "209.237.237." => "Alexa",
        "209.237.238." => "Alexa",
        "209.237.239." => "Alexa",
        "209.237.240." => "Alexa",
        "209.237.241." => "Alexa",
        "209.237.242." => "Alexa",
        "209.237.243." => "Alexa",
        "209.237.244." => "Alexa",
        "209.237.245." => "Alexa",
        "209.237.246." => "Alexa",
        "209.237.247." => "Alexa",
        "209.237.248." => "Alexa",
        "209.237.249." => "Alexa",
        "209.237.250." => "Alexa",
        "209.237.251." => "Alexa",
        "209.237.252." => "Alexa",
        "209.237.253." => "Alexa",
        "209.237.254." => "Alexa",
	"209.237.255." => "Alexa"
);
// "KEY" => "DESC"
// KEY is the username
// DESC describes the function of the username of your site
// This array will be used in the future for excluding users
// from BanOnDemand(SM).
$knights = array("Zhen-Xjell" => "admin",
	"IACOJ" => "admin"
);
/*	End Configuration Section	*/







/* 	Do Not Edit Settings Below	*/

$ver = "Beta 1.20"; // Internal variable for Fortress(TM) version.

if (defined('ZERO')) {

	// Protecting against possible Register_Global attacks
	ReleaseVars();

	$server=$_SERVER["SERVER_NAME"];
	$rawloc=$_SERVER["QUERY_STRING"];
	$loc=rawurldecode($_SERVER["QUERY_STRING"]);
	$addr=$_SERVER["REMOTE_ADDR"];
	$refer=$_SERVER["HTTP_REFERER"];
	$agents=$_SERVER["HTTP_USER_AGENT"];
	$cookies=explode(":", base64_decode($_COOKIE["user"]));
	$authors=explode(":", base64_decode($_COOKIE["admin"]));
	$rawuri=$_SERVER["REQUEST_URI"];
	$uri=rawurldecode($_SERVER["REQUEST_URI"]);
	$port=$_SERVER["REMOTE_PORT"];
	$host=$_SERVER["REMOTE_HOST"];
	if (!$host) { $host = @gethostbyaddr($addr); }
	$humandate=date("l dS of F Y h:i:s A");
	$unixdate=date("U");
	$quest = array("([1AcdDEHJoOpPrRSTvZ]" => "{4,6})",
	        "([dDeEFGlLMRstTVXZ]" => "{6,8})",
	        "([05aeEiIJnNrRsStTUVWXzZ]" => "{6,8})",
	        "([aABdDeEFklpPQRtTuUVXY]" => "{6,8})",
	        "([02cCeElLMNRsStTUVWZ]" => "{6,8})",
	        "([01aAbcCdeEFGhHJlmnNOQrRtTuUV]" => "{8,11})"
        );


} else { 
	Header("Location: index.php");
}


function Bards($tales) {
	global $boulders, $bardvar;

        while (list($botip, $who) = each($boulders)) {
                if(preg_match("/$botip/", "$tales")) {
			$bardvar = TRUE;
                        return;
                }
        }
        BanOnDemand();
}

function AlertLog($method) {
	global $server, $rawloc, $loc, $addr, $refer, $agents, $sitename, $domain, $to, $realname, $ver, $matches, $method, $mailsubject, $cookies, $authors, $uri, $rawuri, $port, $host, $fortfile, $unixdate, $forthtml, $unionbg, $clikebg, $humandate, $bardbg, $bardvar, $tagsbg;

        if ($method == "CLIKE") {
		$matches[1] = "C-Like";
		$bg = $clikebg;
	}
	if ($method == "BAD-TAGS") { 
		$matches[1] = "BAD-TAGS";
		$bg = $tagsbg;
	}

	if (!file_exists($fortfile)) {
		@touch($fortfile);
		@chmod($fortfile, 0770);
		if (is_writeable($fortfile)) {
			if (!$handel = fopen($fortfile, 'a')) {
				Header("Location: index.php");
			}
			$alertinit = "TIMESTAMP,SUSPECT USERNAME,REMOTE IP ADDRESS,REMOTE PORT,REMOTE USER-AGENTS,REMOTE HOSTNAME,SUSPECT AUTHOR,REFERING SITE,METHOD OF ATTACK,URL USED FOR DELIVERY\r\n";
			if (fwrite($handel, $alertinit) === FALSE) {
				Header("Location: index.php");
			}
		}
	}

        if (!file_exists($forthtml)) {
                @touch($forthtml);
                @chmod($forthtml, 0770);
                if (is_writeable($forthtml)) {
                        if (!$handel2 = fopen($forthtml, 'a')) {
                                Header("Location: index.php");
                        }
			$alertinit2 = "<HTML><HEAD><TITLE>Fortress(TM) Alerts</TITLE>"
				."</HEAD><style type=\"text/css\">"
				.".ccops{ color : #FFFFFF; font-size : 10pt; font-family : Arial, Helvetica; }"
				.".fortress{ color : #000000; font-size : 10pt; font-family : Helvetica, Arial; }"
				."</STYLE><BODY><H2><SPAN style=\"FONT-FAMILY: Arial, Helvetica;\">"
				."Fortress(TM) Alerts by Computer Cops - Energized by BanOnDemand(SM)</SPAN></H2>"
				."<A HREF=\"http://computercops.biz\">ComputerCops</a>: Global Security Solutions<BR>"
				."<A HREF=\"http://fortress.cc\">Fortress(TM)</a>: PHP CMS Security<BR></SPAN></H2>"
				."Server: $server <BR>"
				."Spreadsheet: <A HREF=\"/fortress.csv\">fortress.csv</A>"
				."<TABLE cellpadding=1 cellspacing=1 bgcolor=\"navy\" width=100%><TR>"
                        	."<TD><SPAN class=\"ccops\">TIMESTAMP</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">SUSPECT USERNAME</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">REMOTE IP ADDRESS</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">REMOTE PORT</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">REMOTE USER-AGENTS</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">REMOTE HOSTNAME</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">SUSPECT AUTHOR</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">REFERING SITE</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">METHOD OF ATTACK</SPAN></TD>"
				."<TD><SPAN class=\"ccops\">URL USED FOR DELIVERY</SPAN></TD>"
				."</TR>\n";
                        if (fwrite($handel2, $alertinit2) === FALSE) {
                                Header("Location: index.php");
                        }
                }
        }

	if (is_writeable($fortfile)) {
                if (!$bardvar) {
			if (!$handle = fopen($fortfile, 'a')) {
				Header("Location: index.php");
			}
			$alertlog = "$unixdate,$cookies[1],$addr,$port,$agents,$host,$authors[0],$refer,$matches[1],$domain$rawuri\r\n";
			if (fwrite($handle, $alertlog) === FALSE) {
				Header("Location: index.php");
			}
			fclose($handle);
		}
		Header("Location: index.php");
	}

        if (is_writeable($forthtml)) {
                if (!$handle2 = fopen($forthtml, 'a')) {
                        Header("Location: index.php");
                }
		if ($matches[1] == "UNION") { 
			$bg = $unionbg;
		}
		if ($bardvar) { $bg = $bardbg; }
                $alertlog2 = "<TR bgcolor=$bg>"
		."<TD><SPAN class=\"fortress\">[$unixdate]<BR>$humandate</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">" . htmlspecialchars($cookies[1]) . "</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">$addr<BR>"
		."<A HREF=\"http://samspade.org/t/lookat?a=$addr\" TARGET=_BLANK>View 1</A><BR>"
		."<A HREF=\"http://www.dnsstuff.com/tools/ip4r.ch?ip=$addr\" TARGET=_BLANK>View 2</a><BR>"
		."<A HREF=\"http://apps.declude.com/tools/ip4r.ch?ip=$addr\" TARGET=_BLANK>Alt V2</a><BR>"
		."<A HREF=\"http://www.checkdomain.com/cgi-bin/checkdomain.pl?domain=$addr\" TARGET=_BLANK>View 3</a>"
		."</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">$port</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">" . htmlspecialchars($agents) . "</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">$host</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">" . htmlspecialchars($authors[0]) . "</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">" . htmlspecialchars($refer) . "</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">$matches[1]</SPAN></TD>"
		."<TD><SPAN class=\"fortress\">$domain" . htmlspecialchars($rawuri) . "</SPAN></TD></TR>\n";
                if (fwrite($handle2, $alertlog2) === FALSE) {
                        Header("Location: index.php");
                }
                fclose($handle2);
                Header("Location: index.php");
        }

	Header("Location: index.php");
}

function AlertMail($method) {

	global $server, $rawloc, $loc, $addr, $refer, $agents, $sitename, $domain, $to, $realname, $ver, $matches, $method, $mailsubject, $cookies, $authors, $uri, $rawuri, $port, $host, $humandate, $unixdate, $sms1, $sms2, $matches2;

	if ($method == "CLIKE") { $matches[1] = "A C-Like Comment Code Entry"; }
	if ($method == "BAD-TAGS") { $matches[1] = "A bad HTML tag was used"; }
	$body = "Fortress(TM) Alarm!\r\n"
	."---------------\r\n"
	."\r\n"
	."An attack on $server has triggered Fortress(TM) to send a high-priority email to you."
	." Other methods may be included in this attack, but it only takes one to trigger an Alert."
	." It is that trigger which is reported below:\r\n\r\n"
        ."Timestamp: $humandate\r\n"
	."Logtime: $unixdate\r\n"
	."Attack: $matches[1]\r\n"
	."Query: $loc\r\n"
	."Raw Query: $rawloc\r\n"
	."Method: $domain" . "$uri\r\n"
	."Raw Method: $domain" . "$rawuri\r\n"
	."Suspect Host: $host\r\n"
	."Suspect IP: $addr\r\n"
	."Remote Port: $port\r\n"
	."Suspect Agents: $agents\r\n"
	."User Cookie: $cookies[1]\r\n"
	."Admin Cookie: $authors[0]\r\n"
	."Referred: $refer\r\n"
	."\r\n\r\n"
	."---\r\n"
	."Fortress(TM) $ver\r\n"
	."Brought to you exclusively by http://computercops.biz and http://fortress.cc.  Keep it secure!\r\n"
	."BanOnDemand and Fortress are ServiceMarks and TradeMarks of Computer Cops, LLC.\r\n"
        ."2004  Paul Laudanski\r\n";
	$to = $realname . " <$to>";
	$headers = "From: Fortress\r\n"
	."Priority: urgent\r\n"
	."Importance: High\r\n"
	."Precedence: special-delivery\r\n"
        ."Organization: $sitename\r\n"
	."MIME-Version: 1.0\r\n"
	."Content-Type: text/plain\r\n"
	."Content-Transfer-Encoding: 8bit\r\n"
	."X-Priority: 1\r\n"
	."X-MSMail-Priority: High\r\n"
        ."X-Mailer: PHP/" . phpversion() ."\r\n"
	."X-Fortress: $ver by http://computercops.biz and http://fortress.cc\r\n";
	mail($to, $mailsubject, $body, $headers);

	if (!empty($sms1)) { mail($sms1, $mailsubject, $matches[1], "From: Fortress"); }
	if (!empty($sms2)) { mail($sms1, $mailsubject, $matches[1], "From: Fortress"); }

	BanOnDemand();
	Header("Location: index.php");
}

function ReleaseVars() {

	unset($arrows);
	$arrows = array("$addr",
		"$agents",
		"$alertinit",
		"$alertinit2",
		"$alertlog",
		"$alertlog2",
		"$authors",
		"$bardbg",
		"$bardvar",
		"$bg",
		"$BOD",
		"$body",
		"$botip",
		"$boulders",
		"$clikebg",
		"$cookies",
		"$domain",
		"$Food",
		"$fortfile",
		"$forthtml",
		"$handel",
		"$handel2",
		"$handle",
		"$handle2",
		"$headers",
		"$host",
		"$humandate",
		"$knights",
		"$loc",
		"$mailsubject",
		"$matches",
		"$matches2",
		"$method",
		"$port",
		"$quest",
		"$rawloc",
		"$rawuri",
		"$realname",
		"$refer",
		"$rows",
		"$sitename",
		"$sms1",
		"$sms2",
		"$tagsbg",
		"$tales",
		"$to",
		"$unionbg",
		"$unixdate",
		"$uri",
		"$who"
	);

	unset($fired);
	foreach ($arrows as $fired) {
		unset($fired);
	}
}

function ccheck() {
	global $loc, $method;

	if (strstr($loc,"/*")) {
	        $method = "CLIKE";
	        AlertMail($method);
        	AlertLog($method);
	}
}

function ucheck() {
	global $loc, $method, $matches, $matches2, $quest;

	if (preg_match("/([OdWo5NIbpuU4V2iJT0n]{5,7}) /", $loc, $matches)) {
	        while (list($dragons, $fireballs) = each($quest)) {
                	if (preg_match("/ $dragons$fireballs /", $loc, $matches2)) {
        	                $method = "UNION";
	                        AlertMail($method);
                        	AlertLog($method);
                	}
        	}
	}
}

function BanOnDemand() {
	global $addr, $cookies, $fortfile, $BOD;

	if ($BOD) {

		if (is_readable($fortfile)) {
			$handle = fopen($fortfile, "r");
			while (($rows = fgetcsv($handle, 500)) !== FALSE) {
				if ($addr == $rows[2]) {
					fclose($handle);
					Alligators($rows[8]);
				}
				if ($cookies[1] != "") {
					if ($cookies[1] == $rows[1]) {
						fclose($handle);
						Alligators($rows[8]);
					}
				}
			}
			fclose($handle);
		}
	}
}

function Alligators($Food) {
	die("Banned by $Food");
}


/*

CREDITS
The original proof of concept and work in this technology was founded by Allevon,
an Elite Nuker at Nuke Cops and owner of http://allevontech.com.  The email alert
proof of concept was inspired by Mister, a loyal Nuke Cops member and owner of
http://protector.warcenter.se.  Testing was done by dsnail2000, IACOJ, Sting, and
Paul Laudanski (Zhen-Xjell).  As of this release Paul Laudanski is the owner of
Computer Cops, LLC and the founder of http://computercops.biz, http://nukecops.com,
http://fortress.cc, and http://teamhelix.net.

Support the cause!  PayPal: paul@computercops.biz
100 KNIGHTS ($50 Donations)
 1. 3rdCoast Domains - 22 May 2004

250 BARDS ($25 Donations)
 1.

UNLIMITED MINSTRELS ($10 Donations)
 1.

SUPPORT
   If Fortress(TM) is unable to create fortress.csv and fortress.htm then simply create them yourself
using the text below and ensure your web server can append (write) information to them.

"fortress.htm"
[-- CUT --]
<HTML><HEAD><TITLE>Fortress(TM) Alerts</TITLE></HEAD><style type="text/css">.ccops{ color : #FFFFFF; font-size : 10pt; font-family : Arial, Helvetica; }.fortress{ color : #000000; font-size : 10pt; font-family : Helvetica, Arial; }</STYLE><BODY><H2><SPAN style="FONT-FAMILY: Arial, Helvetica;">Fortress(TM) Alerts by Computer Cops - Energized by BanOnDemand(SM)</SPAN></H2><A HREF="http://computercops.biz">ComputerCops</a>: Global Security Solutions<BR><A HREF="http://fortress.cc">Fortress(TM)</a>: PHP CMS Security<BR></SPAN></H2>Server:  <BR>Spreadsheet: <A HREF="/fortress.csv">fortress.csv</A><TABLE cellpadding=1 cellspacing=1 bgcolor="navy" width=100%><TR><TD><SPAN class="ccops">TIMESTAMP</SPAN></TD><TD><SPAN class="ccops">SUSPECT USERNAME</SPAN></TD><TD><SPAN class="ccops">REMOTE IP ADDRESS</SPAN></TD><TD><SPAN class="ccops">REMOTE PORT</SPAN></TD><TD><SPAN class="ccops">REMOTE USER-AGENTS</SPAN></TD><TD><SPAN class="ccops">REMOTE HOSTNAME</SPAN></TD><TD><SPAN class="ccops">SUSPECT AUTHOR</SPAN></TD><TD><SPAN class="ccops">REFERING SITE</SPAN></TD><TD><SPAN class="ccops">METHOD OF ATTACK</SPAN></TD><TD><SPAN class="ccops">URL USED FOR DELIVERY</SPAN></TD></TR>
[-- CUT --]


"fortress.csv"
[-- CUT --]
TIMESTAMP,SUSPECT USERNAME,REMOTE IP ADDRESS,REMOTE PORT,REMOTE USER-AGENTS,REMOTE HOSTNAME,SUSPECT AUTHOR,REFERING SITE,METHOD OF ATTACK,URL USED TO DELIVERY
[-- CUT --]

*/

?>
